'use strict';
var Github = require('github');
var Q = require('q');

var github = new Github({
  version: '3.0.0'
});

function githubRemoveAllReleases(auth, options, done) {
  if (!auth) {
    throw new Error('Expected an auth object');
  }

  github.authenticate(auth);

  Q.nfcall(github.releases.listReleases, options)
    .then(function(data) {
      var deleteReleasePromises = [];

      data.forEach(function(release) {
        deleteReleasePromises.push(Q.nfcall(github.releases.deleteRelease, {
          owner: options.owner,
          repo: options.repo,
          id: release.id
        }));
      });

      return Q.allSettled(deleteReleasePromises);
    })
    .then(function() {
      done();
    }, done);
}

module.exports = githubRemoveAllReleases;
